//@line 39 "/c/Users/barry/prince/mozilla/toolkit/components/console/content/engineconsole.js"

var gEngineConsole, gConsoleBundle;

/* :::::::: Console Initialization ::::::::::::::: */

window.onload = function()
{
  gEngineConsole = document.getElementById("EngineConsoleBox");
  gConsoleBundle = document.getElementById("ConsoleBundle");
  
  updateSortCommand(gEngineConsole.sortOrder);
//  updateModeCommand(gEngineConsole.mode);

//  gEvaluator.addEventListener("load", loadOrDisplayResult, true);
  changeMode("Engine messages");
}

/* :::::::: Console UI Functions ::::::::::::::: */

function changeMode(aMode)
{
  switch (aMode) {
    case "Errors":
    case "Warnings":
    case "Messages":
    case "Engine messages":
      gEngineConsole.mode = aMode;
      break;
    case "All":
      gEngineConsole.mode = null;
  }
  
  document.persist("ConsoleBox", "mode");
}

function clearConsole()
{
  gEngineConsole.clear();
}

function changeSortOrder(aOrder)
{
  updateSortCommand(gEngineConsole.sortOrder = aOrder);
}

function updateSortCommand(aOrder)
{
  var orderString = aOrder == 'reverse' ? "Descend" : "Ascend";
  var bc = document.getElementById("Console:sort"+orderString);
  bc.setAttribute("checked", true);  

  orderString = aOrder == 'reverse' ? "Ascend" : "Descend";
  bc = document.getElementById("Console:sort"+orderString);
  bc.setAttribute("checked", false);
}
//
//function updateModeCommand(aMode)
//{
//  var bc = document.getElementById("Console:mode" + aMode);
//  bc.setAttribute("checked", true);
//}
//
//function onEvalKeyPress(aEvent)
//{
//  if (aEvent.keyCode == 13)
//    evaluateTypein();
//}
//
//function evaluateTypein()
//{
//  gCodeToEvaluate = gTextBoxEval.value;
//  // reset the iframe first; the code will be evaluated in loadOrDisplayResult
//  // below, once about:blank has completed loading (see bug 385092)
//  gEvaluator.contentWindow.location = "about:blank";
//}
//
//function loadOrDisplayResult()
//{
//  if (gCodeToEvaluate) {
//    gEvaluator.contentWindow.location = "javascript: " +
//                                        gCodeToEvaluate.replace(/%/g, "%25");
//    gCodeToEvaluate = "";
//    return;
//  }
//
//  var resultRange = gEvaluator.contentDocument.createRange();
//  resultRange.selectNode(gEvaluator.contentDocument.documentElement);
//  var result = resultRange.toString();
//  if (result)
//    gConsole.mCService.logStringMessage(result);
//    // or could use appendMessage which doesn't persist
//}

// XXX DEBUG
//function debug(aText)
//{
//  var csClass = Components.classes['@mozilla.org/consoleservice;1'];
//  var cs = csClass.getService(Components.interfaces.nsIConsoleService);
//  cs.logStringMessage(aText);
//}
//
//